VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Dim m_hWnd As Long

Property Get hWnd() As Long
Attribute hWnd.VB_UserMemId = 0
    hWnd = m_hWnd
End Property

Property Let hWnd(ByVal New_hWnd As Long)
    m_hWnd = New_hWnd
End Property

Property Get Caption() As String
    Dim sBuffer As String * 255, sLen As Long
    sLen = GetWindowText(m_hWnd, sBuffer, 255)
    Caption = Left$(sBuffer, sLen)
End Property

Property Let Caption(ByVal New_Caption As String)
    SetWindowText m_hWnd, New_Caption
End Property

Property Get WindowState() As Integer
    If IsIconic(m_hWnd) Then
        WindowState = vbMinimized
    ElseIf IsZoomed(m_hWnd) Then
        WindowState = vbMaximized
    Else
        WindowState = vbNormal
    End If
End Property

Property Let WindowState(ByVal New_WindowState As Integer)
    If IsIconic(m_hWnd) Then
        OpenIcon m_hWnd
    ' Left as excersize for you to
    ' set the other two
    End If
End Property

Property Get Left() As Long
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    Left = wndRect.Left
End Property

Property Let Left(ByVal New_Left As Long)
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    MoveWindow m_hWnd, New_Left, wndRect.Top, wndRect.Right - wndRect.Left, wndRect.Bottom - wndRect.Top, True
End Property

Property Get Top() As Long
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    Top = wndRect.Top
End Property

Property Let Top(ByVal New_Top As Long)
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    MoveWindow m_hWnd, wndRect.Left, New_Top, wndRect.Right - wndRect.Left, wndRect.Bottom - wndRect.Top, True
End Property

Property Get Width() As Long
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    Width = wndRect.Right - wndRect.Left
End Property

Property Let Width(ByVal New_Width As Long)
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    MoveWindow m_hWnd, wndRect.Left, wndRect.Top, New_Width, wndRect.Bottom - wndRect.Top
End Property

Property Get Height() As Long
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    Height = wndRect.Bottom - wndRect.Top
End Property

Property Let Height(ByVal New_Height As Long)
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    MoveWindow m_hWnd, wndRect.Left, wndRect.Top, wndRect.Right - wndRect.Left, New_Height
End Property

Property Let OnTop(ByVal New_OnTop As Boolean)
    If New_OnTop Then
        SetWindowPos m_hWnd, HWND_TOPMOST, 0, 0, 0, 0, 3
    Else
        SetWindowPos m_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, 3
    End If
End Property

Property Let Visible(ByVal New_Visible As Boolean)
    If New_Visible Then
        ShowWindow m_hWnd, SW_SHOW
    Else
        ShowWindow m_hWnd, SW_HIDE
    End If
End Property

Sub Move(ByVal Left As Long, Optional ByVal Top As Long, Optional ByVal Width As Long, Optional ByVal Height As Long)
    Dim wndRect As RECT
    GetWindowRect m_hWnd, wndRect
    If IsMissing(Top) Then Top = wndRect.Top
    If IsMissing(Width) Then Width = wndRect.Right - wndRect.Left
    If IsMissing(Height) Then Height = wndRect.Bottom - wndRect.Top
    MoveWindow m_hWnd, Left, Top, Width, Height, True
End Sub
